# SPDX-FileCopyrightText: Copyright (c) 2024, Linaro Limited.
#
# SPDX-FileCopyrightText: <text>Copyright 2022-2024 Arm Limited and/or its
# affiliates <open-source-office@arm.com></text>
#
# SPDX-License-Identifier: MIT
---
device_type: n1sdp
job_name: {{ CI_JOB_NAME }}
timeouts:
  job:
    minutes: 60

{%- if FREQUENCY == 'adhoc' %}
priority: medium
{%- else %}
priority: low
{%- endif %}
visibility:
  group:
    - cassini

metadata:
  source: {{ CI_PROJECT_URL }}
  path: .gitlab/lava/n1sdp/sanity.yml.j2
  gitlab-job-url: {{ CI_JOB_URL }}

notify:
  criteria:
    status: finished
  callbacks:
    - url: "{{ CI_API_V4_URL }}/projects/{{ CI_PROJECT_ID }}/jobs/{{ TEST_COMPLETE_JOB_ID }}/play"
      method: POST
      token: "{{ LAVA_CALLBACK_TOKEN }}"
      header: "PRIVATE-TOKEN"
      dataset: minimal

context:
  extra_nfsroot_args: ',vers=3'
  extra_kernel_args: rootwait

actions:

#
# Deploy a firmware bundle with the customized "uefi.bin" installed. This
# enables an EFI network driver, allowing us to TFTP boot from GRUB.
#
- deploy:
    namespace: recovery
    timeout:
      minutes: 5
    failure_retry: 2
    to: flasher
    images:
      recovery_image:
        url: {{ LAVA_STATIC_FILES_SERVER_URL }}/n1sdp/4/n1sdp-board-firmware-force-netboot.zip
        compression: zip

- deploy:
    namespace: debian
    timeout:
      minutes: 10
    failure_retry: 2
    to: tftp
    os: debian
    kernel:
      url: {{ LAVA_STATIC_FILES_SERVER_URL }}/n1sdp/4/debian/linux
      type: image
    ramdisk:
      url: {{ LAVA_STATIC_FILES_SERVER_URL }}/n1sdp/4/debian/ramdisk.img
    nfsrootfs:
      url: {{ LAVA_STATIC_FILES_SERVER_URL }}/n1sdp/4/debian/debian-buster-arm64-rootfs.tar.xz
      compression: xz

- boot:
    namespace: recovery
    timeout:
      minutes: 5
    method: minimal
    parameters:
      kernel-start-message: ''
    prompts: ['Cmd>']

- boot:
    namespace: uart1
    method: new_connection
    connection: uart1

- boot:
    namespace: uart3
    method: new_connection
    connection: uart3

- boot:
    namespace: debian
    connection-namespace: uart1
    timeout:
      minutes: 5
    method: grub
    commands: nfs
    prompts:
      - '/ # '

- test:
    namespace: debian
    timeout:
      minutes: 5
    definitions:
      - repository:
          metadata:
            format: Lava-Test Test Definition 1.0
            name: install-dependencies
            description: '"Install dependencies for secondary media deployment"'
            os:
              - debian
            scope:
              - functional
          run:
            steps:
              - apt-get update -q
              - apt-get install -qy bmap-tools
              - find /dev/disk
        from: inline
        name: install-dependencies
        path: inline/install-dependencies.yaml

#
# Deploy the primary board firmware bundle (this time without the additional
# network driver).
#
- deploy:
    namespace: recovery
    timeout:
      minutes: 5
    failure_retry: 2
    to: flasher
    images:
      recovery_image:
        url: "{{ FIRMWARE_ARTIFACT }}"
        compression: zip

- deploy:
    namespace: secondary_media
    connection-namespace: uart1
    timeout:
      minutes: 15
    to: usb
    os: oe
    images:
      image:
        url: "{{ IMAGE_ARTIFACT }}"
        compression: gz
      bmap:
        url: "{{ BMAP_ARTIFACT }}"
    uniquify: false
    device: usb_storage_device
    writer:
      tool: /usr/bin/bmaptool
      options: copy {DOWNLOAD_URL} {DEVICE}
      prompt: 'bmaptool: info'
    tool:
      prompts: ['copying time: [0-9ms\.\ ]+, copying speed [0-9\.]+ MiB\/sec']

#
# Do not verify the flash second time around as cached serial output on the
# connection will immediately match the prompt.
#

- boot:
    namespace: secondary_media
    timeout:
      minutes: 10
    method: minimal
    auto_login:
      login_prompt: 'n1sdp login:.*'
      username: cassini
      login_commands:
      - cassini123
      - cassini123
    prompts:
      - 'New password: '
      - 'Re-enter new password: '
      - '@n1sdp:.+\$ '
    transfer_overlay:
      download_command: wget -S
      unpack_command: tar -C / -xzf
